
public final class PriorityNode extends Point {

   public int g;
   public Integer f;
   public PriorityNode prev;
   
   public PriorityNode(int x, int y, PriorityNode prev, Point goal) {
      super(x, y);
      this.prev = prev;
      g = prev == null ? 0 : prev.g + 1;
      f = new Integer(g + distance(goal));
//System.err.println("New node " + this + " g = " + g + ", f = " + f);      //DEBUG
   }
   
   public PriorityNode(Point p, PriorityNode prev, Point goal) {
      this(p.x, p.y, prev, goal);
   }

}