

import java.util.*;

public class PriorityQueue {

   public Hashtable members = new Hashtable();
   public TreeMap q = new TreeMap();
   
   public final void add(PriorityNode n) {
      members.put(n.toString(), n);
      HashSet h = (HashSet) q.get(n.f);
      if (h == null) {
         h = new HashSet();
         q.put(n.f, h);
      }
      h.add(n);
   }
   
   public final PriorityNode popFirst() {
      if (q.size() == 0) return null;
      HashSet h = (HashSet)q.get(q.firstKey());
      if (h != null) {
         Iterator i = h.iterator();
         PriorityNode n = (PriorityNode) i.next();
         i.remove();
         if (h.isEmpty()) {
            q.remove(n.f);
         }
         members.remove(n.toString());
         return n;
      }
      return null;
   }
   
   public final void remove(PriorityNode n) {
      String k = n.toString();
      if (members.containsKey(k)) {
         PriorityNode r = (PriorityNode) members.remove(k);
         HashSet h = (HashSet)q.get(r.f);
         h.remove(r);
         if (h.isEmpty()) q.remove(r.f);
      }
   }
   
   public final PriorityNode find(PriorityNode n) {
      return (PriorityNode) members.get(n.toString());
   }
   
   public final boolean isEmpty() {
      return q.isEmpty();
   }

}